/***
 * Excerpted from "iCloud for Developers",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material, 
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose. 
 * Visit http://www.pragmaticprogrammer.com/titles/cricloud for more book information.
***/
//
//  SMGroceryItem.m
//  grocery
//
//  Created by cesarerocchi on 6/5/12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "SMGroceryItem.h"

@implementation SMGroceryItem

// called when the application reads data from the file
- (BOOL) loadFromContents:(id)contents 
                   ofType:(NSString *)typeName 
                    error:(NSError **)outError {

    if ([contents length] > 0) {
        self.itemName = [[NSString alloc] initWithBytes:[contents bytes] 
                                                 length:[contents length]
                                               encoding:NSUTF8StringEncoding];
    } else {
        self.itemName = @"Unnamed item";
    }
	
    return YES;
}

// called when the app (auto)saves the content to the file
- (id) contentsForType:(NSString *)typeName 
                 error:(NSError **)outError {

    if ([self.itemName length] == 0) {
        self.itemName = @"Unnamed item";
    }
    
    return [NSData dataWithBytes:[self.itemName UTF8String] 
                          length:[self.itemName length]];
}

@end
